// 2011N0709 \tgEFAX^oC[hւ̈ڍsǉ

#include "iodefine.h"
#include "ecu_init.h"
#include "intervaltimer.h"
#include "temp_table.h"
#include "iscv.h"
#include "rotation_speed.h"
#include "injection.h"
#include <machine.h>

volatile unsigned int TIMER=0;

void intervaltimer_init(void)
{
	STB.CR4.BIT._MTU2=0;	//W[Xgbv[h
	MTU25.TSTR.BIT.CSTW=0;	// ^C}[~
	MTU25.TCRW.BIT.TPSC=3;	// ̓NbNI /64
	MTU25.TCCR.BIT.CLRW=1;	// RyA}b`ŃNA
	MTU25.TIER.BIT.TGIEW=1;	// RyA}b`荞݋
	INTC.IPRF.BIT._MTU25=1;	// RyA}b`荞ݗD惌x
	
	// 1JEg 1/IOCLK*64 [s]
	// 1JEg 1/IOCLK*64*1000000 [us]
	//MTU25.TGRW=100ms*1000/(64*1000000/IOCLK)
	//MTU25.TGRW=100ms*1000*100/(64*1000000*100/IOCLK)
	//MTU25.TGRW=100ms*1000*IOCLK/(64*1000000)
	//MTU25.TGRW=100ms*IOCLK/(64*1000)
	// NbN 24MHzƂ傤Ǌ؂̂ 100ms̃^C}[ɂȂ
	// NbN 25MHzƊ؂Ȃ
	MTU25.TGRW=100*IOCLK/(64*1000);	// 100msƂɊ荞
	
	STB.CR4.BIT._AD1=0;		// W[Xgbv[h
	AD1.ADCSR.BIT.STC=1;	// 64Xe[g
	AD1.ADCSR.BIT.CKSL=0;	// NbNZNg 0:/4 1:/3 2:/2 3:
	AD1.ADCSR.BIT.ADM=1;	// 4`lXL
	AD1.ADCSR.BIT.ADCS=0;	// 1TCNXL
	AD1.ADCSR.BIT.CH=3;		// AN4`AN7 XL
	
	AD1_start();	// ڂADϊX^[g  


	TIMER=0;
	MTU25.TSTR.BIT.CSTW=1;	// ^C}[X^[g
}

// R␳}bv
void injcomp_sub(unsigned char r, unsigned char a)
{
	if(INJCOMP_MAP[r][a]!=0)	// ␳֎~̈Ȃ␳Ȃ
	{
		INJCOMP_MAP[r][a]-=1;		// 1%
		if(INJCOMP_MAP[r][a]<AFCMIN)
			INJCOMP_MAP[r][a]=AFCMIN;	// Ȃ悤ɂ
	}
}

// R␳}bv
void injcomp_add(unsigned char r, unsigned char a)
{
	if(INJCOMP_MAP[r][a]!=0)	// ␳֎~̈Ȃ␳Ȃ
	{
		INJCOMP_MAP[r][a]+=1;	// 1%
		if(INJCOMP_MAP[r][a]>AFCMAX)
			INJCOMP_MAP[r][a]=AFCMAX;	// Ȃ悤ɂ
	}
}

void interrupt_mtu25W(void)
{
	// 100msƂɌĂ΂
	static unsigned int O2TIMER;	// O2ZT[픻f int  32bit
	signed int temp;

	TIMER++;
	
	// j[gXCb`̃j^
	if(IN_NEUTRAL==1) STATUS|=SNEUTRAL;
	else STATUS&=~SNEUTRAL;
	
	// GAR[̐
	// GARXCb`ONŃT[XCb`삵Ă΁AGARRvbT[𓮂
	if(IN_AC==0) AC_RELAY=1;
	else AC_RELAY=0;
	
	// X^[gtOĂAxZTُtONA
	// iCPUdĂI/OdĂȂԂƁAAiO͂0VɂȂ
	// ZT[ُƔf邽߃GWnɈُtONAj
	if(IN_START==1)
	{
		STATUS&=~SWATERERR;
		STATUS&=~SAIRERR;
		set_iscv(100);	// ISCVSJ
	}
	
	switch(TIMER%10)
	{
		case 0:	// bƂɎs
				// ᑬADϊ
				// ADϊIĂAlǂł玟ADϊJn
				// iԊu󂢂Ă邩ADF`FbNȂĂƎvǁj
			if(AD1.ADCSR.BIT.ADF==1)
			{
				int a,b;
				// ADϊItONA
				while(AD1.ADCSR.BIT.ADF==1)AD1.ADCSR.BIT.ADF=0;

				// ADϊ̌ʂe[uŉxɕϊ
				WATER_TEMP = WATER_TEMP_TABLE [WATER_TEMP_REG>>8];
				AIR_TEMP   = WATER_TEMP_TABLE [AIR_TEMP_REG>>8];
				OIL_TEMP   = OIL_TEMP_TABLE   [OIL_TEMP_REG>>8];
				
				// xZT[ُ펞25ƂĈ
				if(WATER_TEMP>(130+50))	// ZT[ُ
				{
					WATER_TEMP=25+50;
					STATUS|=SWATERERR;	// xZT[ُtOĂ
				}
				if(WATER_TEMP<(-40+50))	// ZT[ቷُiZT[fj
				{
					WATER_TEMP=25+50;
					STATUS|=SWATERERR;	// xZT[ُtOĂ
				}
				if(AIR_TEMP>(130+50))	// zCZT[ُ
				{
					AIR_TEMP=25+50;
					STATUS|=SAIRERR;	// xZT[ُtOĂ
				}
				if(AIR_TEMP<(-40+50))	// zCZT[ቷُiZT[fj
				{
					AIR_TEMP=25+50;
					STATUS|=SAIRERR;	// xZT[ُtOĂ
				}

				// ␳WvZ
				if(WATER_TEMP<(70+50))	// 70ȏŕ␳Ȃ
				{
					b=(WATER_TEMP+40-50)/10;
					a=WATER_CORRECT_TABLE[b];
					b=WATER_CORRECT_TABLE[b+1];
					WATER_CORRECT=a+((b-a)/10*(WATER_TEMP%10));	// 2_Ԃ̕⊮
				}
				else
				{
					WATER_CORRECT=100;
				}
				
				// zC␳WvZ
				if(AIR_TEMP<(70+50))	// 70ȏŕ␳Ȃ
				{
					b=(AIR_TEMP+40-50)/10;
					a=AIR_CORRECT_TABLE[b];
					b=AIR_CORRECT_TABLE[b+1];
					AIR_CORRECT=a+((b-a)/10*(AIR_TEMP%10));	// 2_Ԃ̕⊮
				}
				else
				{
					AIR_CORRECT=100;
				}
				
				AD1_start();	// ADϊX^[g
			}
			break;

		case 1:
		case 6:
			// 0.5b
			// AChO]

			if((WATER_TEMP<(IDLUP_TEMP+50))// ႢɂAChAbv
			||(IN_PS==0)	// pXe삵ĂAChAbv
			||(IN_AC==0)	// GARĂAChAbv
			||(IN_FAN==0)	// q[^[̃uA[^[ǂĂAChAbv
			/*||(IN_DEF==1)*/	// AftHKĂAChAbv
			||(IN_LIGHT==1)) STATUS|=SIDLUP;	// wbhCg_ĂAChAbv
			else STATUS&=~SIDLUP;

			// GWĂăXbg|WVIDLŃMAj[gŔRJbgĂȂȂ
			// ACh]
			if((RPM!=0)&&(IN_IDL==0)&&(IN_NEUTRAL==0)&&((STATUS&SINJF)!=0))
			{
				static unsigned short lastrpm;	// Ỏ]
				
				if((STATUS&SIDLUP)==0)
				{
					temp=IDL_RPM;
				}
				else
				{
					temp=LOAD_RPM;
				}
				
				temp=(temp-RPM);
				
				if(((signed short)(RPM-lastrpm))<5)	// ㏸ȂISCVĴ҂
				{
					if(temp>  20) idl_control(+5);		// ڕWႩISCVJ
					if(temp> 120) idl_control(+70);		// ڕW肽ႩISCVJ
				}
				
				if(((signed short)(lastrpm-RPM))<5)	// ~ȂISCV̂҂
				{
					if(temp< -60) idl_control(-5);		// ڕW荂ISCV
					if(temp<-500) idl_control(-30);		// ڕW肽񍂂ISCV߂ɕ
				}
				
				lastrpm=RPM;
			}
			break;

		case 2:
		case 7:
			// 0.5b
			
			// O2ZT[ُ픻f
			// n͕KO2ZT[ُtO1ɂȂĂ
			// ZT[̏o͂ω̂mFtONA

			// O2ZT[̏o͂OƈĂAZT[ُtONA
			if(((O2>O2TH)&&((STATUS&SO2)==0)) || ((O2<O2TH)&&((STATUS&SO2)!=0)))
			{
				STATUS&=~SO2ERR;

				// ZT[LtO̎ 10[]*60*10	(10ɂ܂ZT[`FbN)
				// TIMERI[o[t[钼OƋɒ[ɎZȂ邯ǁAׂƂ͋CɂȂ
				// 0xFFFFFFFF*0.1[b]=4294967295*0.1b=7158278[]=119304[]=4971[]I[o[t[Ȃ
				O2TIMER=TIMER+600;	// 60bωȂZT[ُƂAo͂ω܂ŃtB[hobN␳~
				// 10b炢ωȂ炢␳IقȁH
			}

			if(O2TIMER<TIMER)
			{
				STATUS|=SO2ERR;	// ؂ꂽO2ZT[ُtOZbg
			}
			
			if(RPM==0) STATUS|=SO2ERR;	// GW~܂O2ZT[ُtOZbg
			
			if(O2>O2TH)
			{
				STATUS|=SO2;	// b`
			}
			else
			{
				STATUS&=~SO2;	// [
			}

			// O2ZT[tB[hobN␳
			if(((STATUS&
			(SO2DIS				// O2ZT[tB[hobN␳֎~tO1Ȃ␳Ȃ
			|SFUELPOWINC		// ʕ␳ȂO2ZT[tB[hobN␳Ȃix␳̓tB[hobN␳j
			|SO2ERR))==0)		// O2ZT[ُȂ␳Ȃ
			&&((STATUS&SINJF)!=0))	// R˂ĂȂƂ͕␳Ȃ
			{
				unsigned char a,r;
				if((INJAIR%10)<5) a=INJIDX_A1; else a=INJIDX_A2;		// ԋ߂}XI
				if((INJRPM%500)<250) r=INJIDX_R1; else r=INJIDX_R2;
				
				if((STATUS&SO2)==0)
				{
					// [
					// 瑝ʕ␳
					injcomp_add(r,a);
				}
				else
				{
					// b`
					// Z猸ʕ␳
					injcomp_sub(r,a);
				}
				// tB[hobN␳̓p[W\mChouJĂ
				// ip[W\mChouJċR䂪ZȂĂ␳j
				PURGE=1;
			}
			else
			{
				// tB[hobN␳łȂ΃p[W\mChouĂ
				PURGE=0;
			}
			break;
			
		case 9:
			// 1b
			// ]~Ă΂炭\tgEFAX^oC[hɈڍsiȓd́j
			// IRQ0iNNAONej荞݂ŕA
			{
				static unsigned char count;

				if(RPM==0) count++;
				else count=0;
				
				if(count>60)	// 60bȏ]ĂȂ
				{
					WDTstop();
					WDTclr();
					WDT_init();
					
					CPUdriving=0;	// X[vɓ邱ƂL^
					set_imask(0);	// X[v̕AɔāA荞݃}XN0ZbgisvHj
					
					// STBY  STBYMD Aۂ 1 ɂȂ܂Őɐi܂Ȃ
					while(STB.CR1.BIT.STBY==0) STB.CR1.BIT.STBY=1;
					while(STB.CR6.BIT.STBYMD==0) STB.CR6.BIT.STBYMD=1;
					
					sleep();
				}
			}
			break;
	}
	
	// 荞݃tONA
	// tÕNAmF܂Ői܂Ȃ
	while(MTU25.TSR.BIT.CMFW==1)MTU25.TSR.BIT.CMFW=0;
}